=== modified file 'BRANCH.TODO'
--- BRANCH.TODO	2006-04-18 04:38:44 +0000
+++ BRANCH.TODO	2006-05-27 05:54:50 +0000
@@ -1,3 +1,5 @@
 # This file is for listing TODOs for branches that are being worked on.
 # It should ALWAYS be empty in the mainline or in integration branches.
 # 
+
+Test osutils.file_kind for more than just regular files and directories

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2006-05-27 02:53:39 +0000
+++ bzrlib/osutils.py	2006-05-27 05:54:50 +0000
@@ -25,6 +25,7 @@
 import re
 import sha
 import shutil
+import stat
 import string
 import sys
 import time
@@ -75,23 +76,20 @@
         return f
 
 
+_formats = {
+    stat.S_IFDIR:'directory',
+    stat.S_IFCHR:'chardev',
+    stat.S_IFBLK:'block',
+    stat.S_IFREG:'file',
+    stat.S_IFIFO:'fifo',
+    stat.S_IFLNK:'symlink',
+    stat.S_IFSOCK:'socket',
+}
 def file_kind(f):
-    mode = os.lstat(f)[ST_MODE]
-    if S_ISREG(mode):
-        return 'file'
-    elif S_ISDIR(mode):
-        return 'directory'
-    elif S_ISLNK(mode):
-        return 'symlink'
-    elif S_ISCHR(mode):
-        return 'chardev'
-    elif S_ISBLK(mode):
-        return 'block'
-    elif S_ISFIFO(mode):
-        return 'fifo'
-    elif S_ISSOCK(mode):
-        return 'socket'
-    else:
+    fmt = stat.S_IFMT(os.lstat(f).st_mode)
+    try:
+        return _formats[fmt]
+    except KeyError:
         return 'unknown'
 
 

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2006-05-05 01:15:53 +0000
+++ bzrlib/tests/test_osutils.py	2006-05-27 05:54:50 +0000
@@ -90,6 +90,15 @@
         self.failIfExists('dir/file')
         self.failIfExists('dir')
 
+    def test_file_kind(self):
+        self.build_tree(['file', 'dir/'])
+        self.assertEquals('file', osutils.file_kind('file'))
+        self.assertEquals('directory', osutils.file_kind('dir/'))
+        if osutils.has_symlinks():
+            os.symlink('symlink', 'symlink')
+            self.assertEquals('symlink', osutils.file_kind('symlink'))
+        #TODO: jam 20060527 Test nodes, sockets, fifos, etc
+
 
 class TestSafeUnicode(TestCase):
 

